var _inherits = require('babel-runtime/helpers/inherits').default;

var _classCallCheck = require('babel-runtime/helpers/class-call-check').default;

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;

var _baseDomAdapter = require('./base-dom-adapter');

var _baseDomAdapter2 = _interopRequireDefault(_baseDomAdapter);

var _events = require('events');

var _events2 = _interopRequireDefault(_events);

var _utilsUrlJs = require('../../utils/url.js');

var _utilsUrlJs2 = _interopRequireDefault(_utilsUrlJs);

var ServerDomAdapter = (function (_BaseDomAdapter) {
    _inherits(ServerDomAdapter, _BaseDomAdapter);

    function ServerDomAdapter(isIframe, crossDomainPort) {
        _classCallCheck(this, ServerDomAdapter);

        _BaseDomAdapter.call(this);

        this.isIframe = isIframe;
        this.crossDomainPort = crossDomainPort;
    }

    ServerDomAdapter.prototype.getAttr = function getAttr(el, attr) {
        return el.attribs[attr];
    };

    ServerDomAdapter.prototype.hasAttr = function hasAttr(el, attr) {
        return attr in el.attribs;
    };

    ServerDomAdapter.prototype.hasEventHandler = function hasEventHandler(el) {
        for (var attr in el.attribs) {
            if (this.EVENTS.indexOf(el.attribs[attr])) return true;
        }

        return false;
    };

    ServerDomAdapter.prototype.getTagName = function getTagName(el) {
        return el.name;
    };

    ServerDomAdapter.prototype.setAttr = function setAttr(el, attr, value) {
        var result = el.attribs[attr] = value;

        return result;
    };

    ServerDomAdapter.prototype.setScriptContent = function setScriptContent(script, content) {
        script.children[0].data = content;
    };

    ServerDomAdapter.prototype.getScriptContent = function getScriptContent(script) {
        // The $script.html() method is not used because it is not working properly, it adds garbage in the result.
        var contentChild = script.children.length ? script.children[0] : null;

        return contentChild ? contentChild.data : '';
    };

    ServerDomAdapter.prototype.getStyleContent = function getStyleContent(style) {
        // The $el.html() method is not used because it is not working properly, it adds garbage in the result.
        var contentChild = style.children.length ? style.children[0] : null;

        return contentChild && contentChild.data ? contentChild.data : null;
    };

    ServerDomAdapter.prototype.setStyleContent = function setStyleContent(style, content) {
        var contentChild = style.children.length ? style.children[0] : null;

        if (contentChild && contentChild.data) contentChild.data = content;
    };

    ServerDomAdapter.prototype.getElementForSelectorCheck = function getElementForSelectorCheck(el) {
        return el;
    };

    ServerDomAdapter.prototype.needToProcessUrl = function needToProcessUrl(tagName, target) {
        if (this.IFRAME_FLAG_TAGS.indexOf(tagName) !== -1 && target === '_parent') return false;

        return true;
    };

    ServerDomAdapter.prototype.attachEventEmitter = function attachEventEmitter(domProcessor) {
        var eventEmitter = new _events2.default.EventEmitter();

        domProcessor.on = eventEmitter.on.bind(eventEmitter);
        domProcessor.off = eventEmitter.removeListener.bind(eventEmitter);
        domProcessor.emit = eventEmitter.emit.bind(eventEmitter);
    };

    ServerDomAdapter.prototype.hasIFrameParent = function hasIFrameParent() {
        return this.isIframe;
    };

    ServerDomAdapter.prototype.getCrossDomainPort = function getCrossDomainPort() {
        return this.crossDomainPort;
    };

    ServerDomAdapter.prototype.getProxyUrl = function getProxyUrl() {
        return _utilsUrlJs2.default.getProxyUrl.apply(_utilsUrlJs2.default, arguments);
    };

    ServerDomAdapter.prototype.isTopParentIFrame = function isTopParentIFrame() {
        return false;
    };

    return ServerDomAdapter;
})(_baseDomAdapter2.default);

exports.default = ServerDomAdapter;
module.exports = exports.default;
//# sourceMappingURL=server-dom-adapter.js.map
