var _taggedTemplateLiteralLoose = require('babel-runtime/helpers/tagged-template-literal-loose').default;

var _inherits = require('babel-runtime/helpers/inherits').default;

var _classCallCheck = require('babel-runtime/helpers/class-call-check').default;

var _Symbol = require('babel-runtime/core-js/symbol').default;

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;

var _templateObject = _taggedTemplateLiteralLoose(['\n    <script type="text/javascript" class="', '">\n        if (window.Hammerhead)\n            window.Hammerhead.sandbox.node.raiseBodyCreatedEvent();\n\n        var script = document.currentScript || document.scripts[document.scripts.length - 1];\n        script.parentNode.removeChild(script);\n    </script>\n'], ['\n    <script type="text/javascript" class="', '">\n        if (window.Hammerhead)\n            window.Hammerhead.sandbox.node.raiseBodyCreatedEvent();\n\n        var script = document.currentScript || document.scripts[document.scripts.length - 1];\n        script.parentNode.removeChild(script);\n    </script>\n']);

var _const = require('../../const');

var _const2 = _interopRequireDefault(_const);

var _dom = require('../dom');

var _dom2 = _interopRequireDefault(_dom);

var _domServerDomAdapter = require('../dom/server-dom-adapter');

var _domServerDomAdapter2 = _interopRequireDefault(_domServerDomAdapter);

var _resourceProcessorBase = require('./resource-processor-base');

var _resourceProcessorBase2 = _interopRequireDefault(_resourceProcessorBase);

var _whacko = require('whacko');

var _whacko2 = _interopRequireDefault(_whacko);

var _dedent = require('dedent');

var _dedent2 = _interopRequireDefault(_dedent);

var _script = require('../script');

var _script2 = _interopRequireDefault(_script);

var BODY_CREATED_EVENT_SCRIPT = _dedent2.default(_templateObject, _const2.default.SHADOW_UI_SCRIPT_CLASSNAME);

var PageProcessor = (function (_ResourceProcessorBase) {
    _inherits(PageProcessor, _ResourceProcessorBase);

    function PageProcessor() {
        _classCallCheck(this, PageProcessor);

        _ResourceProcessorBase.call(this);

        this.RESTART_PROCESSING = _Symbol();

        this.domProcessor = new _dom2.default(new _domServerDomAdapter2.default());
    }

    PageProcessor._getPageProcessingOptions = function _getPageProcessingOptions(ctx, urlReplacer) {
        return {
            crossDomainProxyPort: ctx.serverInfo.crossDomainPort,
            isIFrame: ctx.isIFrame,
            styleUrl: ctx.getInjectableStyles()[0],
            scripts: ctx.getInjectableScripts(),
            urlReplacer: urlReplacer,
            isIframeWithImageSrc: ctx.contentInfo && ctx.contentInfo.isIFrameWithImageSrc
        };
    };

    PageProcessor.prototype._getPageMetas = function _getPageMetas($) {
        var metas = [];

        $('meta').each(function (index, meta) {
            var $meta = $(meta);

            metas.push({
                httpEquiv: $meta.attr('http-equiv'),
                content: $meta.attr('content'),
                charset: $meta.attr('charset')
            });
        });

        return metas;
    };

    PageProcessor.prototype._addPageResources = function _addPageResources($, processingOptions) {
        var resources = [];

        if (processingOptions.styleUrl) {
            resources.push('<link rel="stylesheet" type="text/css" class="' + _const2.default.SHADOW_UI_STYLESHEET_FULL_CLASSNAME + '"' + ('href="' + processingOptions.styleUrl + '">'));
        }

        if (processingOptions.scripts) {
            processingOptions.scripts.forEach(function (scriptUrl) {
                resources.push('<script type="text/javascript" class="' + _const2.default.SHADOW_UI_SCRIPT_CLASSNAME + '"' + ('charset="UTF-8" src="' + scriptUrl + '"></script>'));
            });
        }

        if (resources.length) $('head').prepend(resources.join(''));
    };

    PageProcessor._addCharsetInfo = function _addCharsetInfo($, charset) {
        $($('.' + _const2.default.SHADOW_UI_SCRIPT_CLASSNAME)[0]).before('<meta class="' + _const2.default.SHADOW_UI_CHARSET_CLASSNAME + '" charset="' + charset + '">');
    };

    PageProcessor._changeMetas = function _changeMetas($) {
        // TODO: figure out how to emulate the behavior of the tag
        $('meta[name="referrer"][content="origin"]').remove();
        // NOTE: Remove existing compatible meta tag and add a new at the beginning of the head
        $('meta[http-equiv="X-UA-Compatible"]').remove();
        $('head').prepend('<meta http-equiv="X-UA-Compatible" content="IE=edge" />');
    };

    PageProcessor._prepareHtml = function _prepareHtml(html, processingOpts) {
        if (processingOpts && processingOpts.iframeImageSrc) return '<html><body><img src="' + processingOpts.iframeImageSrc + '" /></body></html>';

        return html;
    };

    PageProcessor._addBodyCreatedEventScript = function _addBodyCreatedEventScript($) {
        $('body').prepend(BODY_CREATED_EVENT_SCRIPT);
    };

    PageProcessor.prototype.shouldProcessResource = function shouldProcessResource(ctx) {
        return ctx.isPage || ctx.contentInfo.isIFrameWithImageSrc;
    };

    PageProcessor.prototype.processResource = function processResource(html, ctx, charset, urlReplacer, processingOpts) {
        processingOpts = processingOpts || PageProcessor._getPageProcessingOptions(ctx, urlReplacer);

        var bom = _script2.default.getBOM(html);

        html = bom ? html.replace(bom, '') : html;

        PageProcessor._prepareHtml(html, processingOpts);

        var $ = _whacko2.default.load(html);

        if (charset.fromMeta(this._getPageMetas($))) return this.RESTART_PROCESSING;

        var pageProcessor = this;

        var iframeHtmlProcessor = function (iframeHtml, callback) {
            var storedIsIframe = processingOpts.isIFrame;

            processingOpts.isIFrame = true;

            var result = pageProcessor.processResource(iframeHtml, ctx, charset, urlReplacer, processingOpts);

            processingOpts.isIFrame = storedIsIframe;

            callback(result);
        };

        var domProcessor = new _dom2.default(new _domServerDomAdapter2.default(processingOpts.isIFrame, processingOpts.crossDomainProxyPort));

        domProcessor.on(domProcessor.HTML_PROCESSING_REQUIRED_EVENT, iframeHtmlProcessor);
        domProcessor.processPage($, processingOpts.urlReplacer);
        domProcessor.off(domProcessor.HTML_PROCESSING_REQUIRED_EVENT, iframeHtmlProcessor);

        this._addPageResources($, processingOpts);
        PageProcessor._addBodyCreatedEventScript($);
        PageProcessor._changeMetas($);
        PageProcessor._addCharsetInfo($, charset.get());

        return (bom || '') + $.html();
    };

    return PageProcessor;
})(_resourceProcessorBase2.default);

exports.default = new PageProcessor();
module.exports = exports.default;
//# sourceMappingURL=page.js.map
