var _classCallCheck = require('babel-runtime/helpers/class-call-check').default;

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var _js = require('./js');

var _js2 = _interopRequireDefault(_js);

var _const = require('../const');

// Byte Order Mark
var BOM_REGEX = new RegExp('^(\\xEF\\xBB\\xBF|' + '\\xFE\\xFF|' + '\\xFF\\xFE|' + '\\x00\\x00\\xFE\\xFF|' + '\\xFF\\xFE\\x00\\x00|' + '\\x2B\\x2F\\x76\\x38|' + '\\x2B\\x2F\\x76\\x39|' + '\\x2B\\x2F\\x76\\x2B|' + '\\x2B\\x2F\\x76\\x2F|' + '\\xF7\\x64\\x4C|' + '\\xDD\\x73\\x66\\x73|' + '\\x0E\\xFE\\xFF|' + '\\xFB\\xEE\\x28|' + '\\x84\\x31\\x95\\x33)');

var ScriptProcessor = (function () {
    function ScriptProcessor() {
        _classCallCheck(this, ScriptProcessor);

        this.OVERRIDE_DOM_METH_SCRIPT = 'window["' + _const.DOM_SANDBOX_OVERRIDE_DOM_METHOD_NAME + '"]';

        this.SCRIPT_HEADER = '\r\ntypeof window !== "undefined" && ' + this.OVERRIDE_DOM_METH_SCRIPT + ' && ' + this.OVERRIDE_DOM_METH_SCRIPT + '();\r\n' + _js2.default.MOCK_ACCESSORS;

        this.SCRIPT_HEADER_REG_EX = new RegExp('^\\s*typeof[^\\n]+' + _const.DOM_SANDBOX_OVERRIDE_DOM_METHOD_NAME.replace('|', '\\|') + '[^\\n]+\\n[^\\n]+\\n[^\\n]+\\n[^\\n]+\\n[^\\n]+\\n[^\\n]+\\n[^\\n]+\\n[^\\n]+__proc\\$Script;', 'i');
    }

    ScriptProcessor.prototype.process = function process(text, withoutHeader) {
        var bom = this.getBOM(text);

        if (bom) text = text.replace(bom, '');

        text = _js2.default.process(text);

        // Overriding methods that work with the DOM.
        if (!_js2.default.isDataScript(text) && !withoutHeader && text.indexOf(_const.DOM_SANDBOX_OVERRIDE_DOM_METHOD_NAME) === -1) text = this.SCRIPT_HEADER + text;

        return bom ? bom + text : text;
    };

    ScriptProcessor.prototype.getBOM = function getBOM(text) {
        var match = text.match(BOM_REGEX);

        return match ? match[0] : null;
    };

    return ScriptProcessor;
})();

exports.default = new ScriptProcessor();
module.exports = exports.default;
//# sourceMappingURL=script.js.map
