exports.__esModule = true;
exports.default = promisify;

var _es6Promise = require('es6-promise');

function promisify(fn) {
    return function () {
        var _this = this;

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return new _es6Promise.Promise(function (resolve, reject) {
            args.push(function (err, res) {
                if (err) reject(err);else resolve(res);
            });

            var res = fn.apply(_this, args);
            var isPromiseResult = res && (typeof res === 'object' || typeof res === 'function') && typeof res.then === 'function';

            if (isPromiseResult) resolve(res);
        });
    };
}

module.exports = exports.default;
//# sourceMappingURL=promisify.js.map
